﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using HeuristicLab.Algorithms.DataAnalysis.Experimental;
using HeuristicLab.Problems.DataAnalysis;

namespace Main {
  class Program {
    static void Main(string[] args) {
      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.VariousInstanceProvider();
      var problemData = provider.LoadData(provider.GetDataDescriptors().First(dd => dd.Name.Contains("Poly")));
      // var provider = new HeuristicLab.Problems.Instances.DataAnalysis.RegressionRealWorldInstanceProvider();
      // var problemData = provider.LoadData(provider.GetDataDescriptors().First(dd => dd.Name.Contains("Chem")));

      var gam = new GAM();
      gam.MaxIterations = 10;
      gam.MaxInteractions = 3;
      gam.Problem.ProblemData = problemData;
      gam.Start();

      var solution = (IRegressionSolution)gam.Results["Ensemble solution"].Value;

      Console.WriteLine("RMSE (train) {0}", solution.TrainingRootMeanSquaredError);
      Console.WriteLine("RMSE (test) {0}", solution.TestRootMeanSquaredError);
    }
  }
}
